<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>A real-life example of contribution to a LabVIEW open-source project</title><meta name="author" content="Olivier Jourdan &lt;olivier.jourdan@wovalab.com&gt;; Paul Morris &lt;paul@acoustics.co.uk&gt;"><link rel="stylesheet" href="reveal.js/css/reset.css"><link rel="stylesheet" href="reveal.js/css/reveal.css"><link rel="stylesheet" href="reveal.js/css/theme/sky.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right {
  float: right
}

/* listing block */
.reveal .listingblock.stretch > .content {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre {
  height: 100%
}

.reveal .listingblock.stretch > .content > pre > code {
  height: 100%;
  max-height: 100%
}

/* tables */
table {
  border-collapse: collapse;
  border-spacing: 0
}

table {
  margin-bottom: 1.25em;
  border: solid 1px #dedede
}

table thead tr th, table thead tr td, table tfoot tr th, table tfoot tr td {
  padding: .5em .625em .625em;
  font-size: inherit;
  text-align: left
}

table tr th, table tr td {
  padding: .5625em .625em;
  font-size: inherit
}

table thead tr th, table tfoot tr th, table tbody tr td, table tr td, table tfoot tr td {
  display: table-cell;
  line-height: 1.6
}

td.tableblock > .content {
  margin-bottom: 1.25em
}

td.tableblock > .content > :last-child {
  margin-bottom: -1.25em
}

table.tableblock, th.tableblock, td.tableblock {
  border: 0 solid #dedede
}

table.grid-all > thead > tr > .tableblock, table.grid-all > tbody > tr > .tableblock {
  border-width: 0 1px 1px 0
}

table.grid-all > tfoot > tr > .tableblock {
  border-width: 1px 1px 0 0
}

table.grid-cols > * > tr > .tableblock {
  border-width: 0 1px 0 0
}

table.grid-rows > thead > tr > .tableblock, table.grid-rows > tbody > tr > .tableblock {
  border-width: 0 0 1px
}

table.grid-rows > tfoot > tr > .tableblock {
  border-width: 1px 0 0
}

table.grid-all > * > tr > .tableblock:last-child, table.grid-cols > * > tr > .tableblock:last-child {
  border-right-width: 0
}

table.grid-all > tbody > tr:last-child > .tableblock, table.grid-all > thead:last-child > tr > .tableblock, table.grid-rows > tbody > tr:last-child > .tableblock, table.grid-rows > thead:last-child > tr > .tableblock {
  border-bottom-width: 0
}

table.frame-all {
  border-width: 1px
}

table.frame-sides {
  border-width: 0 1px
}

table.frame-topbot, table.frame-ends {
  border-width: 1px 0
}

.reveal table th.halign-left, .reveal table td.halign-left {
  text-align: left
}

.reveal table th.halign-right, .reveal table td.halign-right {
  text-align: right
}

.reveal table th.halign-center, .reveal table td.halign-center {
  text-align: center
}

.reveal table th.valign-top, .reveal table td.valign-top {
  vertical-align: top
}

.reveal table th.valign-bottom, .reveal table td.valign-bottom {
  vertical-align: bottom
}

.reveal table th.valign-middle, .reveal table td.valign-middle {
  vertical-align: middle
}

table thead th, table tfoot th {
  font-weight: bold
}

tbody tr th {
  display: table-cell;
  line-height: 1.6
}

tbody tr th, tbody tr th p, tfoot tr th, tfoot tr th p {
  font-weight: bold
}

thead {
  display: table-header-group
}

.reveal table.grid-none th, .reveal table.grid-none td {
  border-bottom: 0 !important
}

/* kbd macro */
kbd {
  font-family: "Droid Sans Mono", "DejaVu Sans Mono", monospace;
  display: inline-block;
  color: rgba(0, 0, 0, .8);
  font-size: .65em;
  line-height: 1.45;
  background: #f7f7f7;
  border: 1px solid #ccc;
  -webkit-border-radius: 3px;
  border-radius: 3px;
  -webkit-box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em white inset;
  box-shadow: 0 1px 0 rgba(0, 0, 0, .2), 0 0 0 .1em #fff inset;
  margin: 0 .15em;
  padding: .2em .5em;
  vertical-align: middle;
  position: relative;
  top: -.1em;
  white-space: nowrap
}

.keyseq kbd:first-child {
  margin-left: 0
}

.keyseq kbd:last-child {
  margin-right: 0
}

/* callouts */
.conum[data-value] {
  display: inline-block;
  color: #fff !important;
  background: rgba(0, 0, 0, .8);
  -webkit-border-radius: 50%;
  border-radius: 50%;
  text-align: center;
  font-size: .75em;
  width: 1.67em;
  height: 1.67em;
  line-height: 1.67em;
  font-family: "Open Sans", "DejaVu Sans", sans-serif;
  font-style: normal;
  font-weight: bold
}

.conum[data-value] * {
  color: #fff !important
}

.conum[data-value] + b {
  display: none
}

.conum[data-value]:after {
  content: attr(data-value)
}

pre .conum[data-value] {
  position: relative;
  top: -.125em
}

b.conum * {
  color: inherit !important
}

.conum:not([data-value]):empty {
  display: none
}

/* Callout list */
.hdlist > table, .colist > table {
  border: 0;
  background: none
}

.hdlist > table > tbody > tr, .colist > table > tbody > tr {
  background: none
}

td.hdlist1, td.hdlist2 {
  vertical-align: top;
  padding: 0 .625em
}

td.hdlist1 {
  font-weight: bold;
  padding-bottom: 1.25em
}

/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child {
  padding: .4em .75em 0;
  line-height: 1;
  vertical-align: top
}

.colist td:not([class]):first-child img {
  max-width: none
}

.colist td:not([class]):last-child {
  padding: .25em 0
}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table {
  border: 0
}

/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist > table th, .reveal .colist > table td {
  border-bottom: 0
}

/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td {
  line-height: inherit
}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
}

.columns .slide-content > .column > * {
  padding: .75rem;
}

/* See #353 */
.columns.wrap .slide-content > .column {
  flex-basis: auto;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.columns .slide-content > .column.has-text-left {
  text-align: left;
}

.columns .slide-content > .column.has-text-justified {
  text-align: justify;
}

.columns .slide-content > .column.has-text-right {
  text-align: right;
}

.text-left {
  text-align: left !important
}

.text-right {
  text-align: right !important
}

.text-center {
  text-align: center !important
}

.text-justify {
  text-align: justify !important
}

.footnotes {
  border-top: 1px solid rgba(0, 0, 0, 0.2);
  padding: 0.5em 0 0 0;
  font-size: 0.65em;
  margin-top: 4em;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "reveal.js/css/print/pdf.css" : "reveal.js/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script><link rel="stylesheet" href="css/wovalab.css"><a href="https://www.wovalab.com">
    <img style="position: absolute; top: 95%; left: 90%; border: 0;" width="160" height="36" src="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_header.png" class="custom-logo" alt="wovalab" itemprop="logo" srcset="https://www.wovalab.com/wp-content/uploads/2018/12/Wovalab_logo_H_RVB_1200.png 2x">
</a>

<p style="position: absolute; top: 96%; left: 47.7%; border: 0;" xmlns:cc="http://creativecommons.org/ns#" ><a href="http://creativecommons.org/licenses/by-sa/4.0/?ref=chooser-v1" target="_blank" rel="license noopener noreferrer" style="display:inline-block;"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/cc.svg?ref=chooser-v1"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/by.svg?ref=chooser-v1"><img style="height:22px!important;margin-left:3px;vertical-align:text-bottom;" src="https://mirrors.creativecommons.org/presskit/icons/sa.svg?ref=chooser-v1"></a></p>

<a href="https://www.acoustics.co.uk/">
    <img style="position: absolute; top: 95%; right: 90%; border: 0;" width="160" height="36" src="https://www.acoustics.co.uk/wp-content/uploads/2022/01/pa-logo.svg" class="custom-logo" alt="Precision Acoustics" itemprop="logo" srcset="https://www.acoustics.co.uk/wp-content/uploads/2022/01/pa-logo.svg 2x">
</a></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title" data-background-image="images/intro.png"><h1>A real-life example of contribution to a LabVIEW open-source project</h1><p class="author"><small>Olivier Jourdan &lt;olivier.jourdan@wovalab.com&gt;; Paul Morris &lt;paul@acoustics.co.uk&gt;</small></p></section><section id="_our_giants_are_female"><h2>#Our Giants are Female</h2><div class="slide-content"><div class="paragraph"><p>Dana Lewis</p></div>
<table class="tableblock frame-none grid-none" style="width:100%"><colgroup><col style="width:35%"><col style="width:65%"></colgroup><tbody><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p><span class="image"><img src="images/Dana%20Lewis.jpg" alt="Dana Lewis" title="https://www.geekwire.com/2017/dana-lewis/"></span></p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>After building her own DIY “artificial pancreas,” Dana Lewis helped found the open source artificial pancreas movement (known as “OpenAPS”), making safe and effective automated insulin delivery technology available (sooner) for people with diabetes around the world for the past 8 years.</p></div>
<div class="ulist"><ul><li><p><a href="https://openaps.org/">OpenAPS.org</a></p></li><li><p><a href="https://diyps.org/">DIYPS.org</a></p></li><li><p><a href="https://www.artificialpancreasbook.com/">ArtificialPancreasBook.com</a></p></li></ul></div></div></td></tr></table>
<aside class="notes"><div class="paragraph"><p>Paul:
For the last 4 years I&#8217;ve been using the Android Artifical Pancreas System app - an open source project based on Danas early and continued work - to manage my own diabetes. To think I&#8217;m actually kept alive by an open source project is pretty cool!</p></div></aside></div></section>
<section><section id="_labview_open_source_projects" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>LabVIEW open-source projects</h2><div class="slide-content"><aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section><section id="_what_open_source_project_usually_means"><h2>What "open-source project" usually means</h2><div class="slide-content"><div class="ulist"><ul><li><p>Free to use</p></li><li><p>Available source code</p></li><li><p>Contribution from different developers</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div>
<div class="paragraph"><p>In the real life, the last point is really rare.
I have no statistics to back that up, it&#8217;s more of a feeling.
At least in more than 20 years of LV development, I started to hear about open-source in the LabVIEW world 2 or 3 years ago</p></div></aside></div></section><section id="_the_usual_labview_open_source_project"><h2>The usual LabVIEW open-source project</h2><div class="slide-content"><div class="ulist"><ul><li><p>One developer (the maintainer)</p></li><li><p>99% of the development is made by the one developer/maintainer</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section><section id="_contribution_to_the_labview_open_source_project"><h2>Contribution to the LabVIEW open-source project</h2><div class="slide-content"><div class="ulist"><ul><li><p>Contributor can access the code through a public project on GitLab/GitHub/Bitbucket</p></li><li><p>Contributor will need to share his code modifications with the developer/maintainer</p></li></ul></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content">only the developer/maintainer has written permission on the project repository</td></tr></table></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div>
<div class="paragraph"><p>There are many ways to contribute to an open-source project:</p></div>
<div class="ulist"><ul><li><p>Testing and reporting issues</p></li><li><p>Assisting or supporting users of the projects</p></li><li><p>Improving the documentation</p></li><li><p>fixing issues</p></li><li><p>Implementing features</p></li></ul></div></aside></div></section></section>
<section><section id="_a_real_use_case_of_a_successful_contribution" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>A real use case of a successful contribution</h2><div class="slide-content"><aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section><section id="_im_the_maintainer"><h2>I&#8217;m the maintainer</h2><div class="slide-content"><div class="ulist"><ul><li><p>The project is the <a href="https://www.vipm.io/package/wovalab_lib_asciidoc_for_labview/">AsciiDoc toolkit for LabVIEW</a></p></li></ul></div>
<div class="imageblock"><img src="images/asciidoc-for-labview.png" alt="asciidoc for labview" width="30%"></div>
<div class="admonitionblock note"><table><tr><td class="icon"><i class="fa fa-info-circle" title="Note"></i></td><td class="content">This project provides an API to create plain-text files using the AsciiDoc syntax. Those files can be processed to get a publishable format (PDF, HTML…).</td></tr></table></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section><section id="_im_the_contributor"><h2>I&#8217;m the contributor</h2><div class="slide-content"><div class="ulist"><ul><li><p>Why AsciiDoc?</p><div class="ulist"><ul><li><p>Measurement report generation</p></li><li><p>Alternative to pdf authoring - final format agnostic</p></li></ul></div></li><li><p>What it couldn&#8217;t do</p></li></ul></div>
<table class="tableblock frame-all grid-all" style="width:100%"><colgroup><col style="width:15%"><col style="width:20%"><col style="width:65%"></colgroup><tbody><tr><th class="tableblock halign-left valign-top"><p class="tableblock header">Type</p></th><th class="tableblock halign-left valign-top"><p class="tableblock header">Result</p></th><th class="tableblock halign-left valign-top"><p class="tableblock header">Image</p></th></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>R1,C0</p></div></div></td><td class="tableblock halign-left valign-top"><div><table class="tableblock frame-all grid-all" style="width:100%"><colgroup><col style="width:33.3333%"><col style="width:33.3333%"><col style="width:33.3334%"></colgroup><tbody><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>00</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>01</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>02</p></div></div></td></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>10</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>11</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>12</p></div></div></td></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>20</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>21</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>22</p></div></div></td></tr></table></div></td><td class="tableblock halign-left valign-top"><div><div class="imageblock"><img src="images/UT%20Coints.jpeg" alt="UT Coints"></div></div></td></tr></table>
<aside class="notes"><div class="paragraph"><p>Paul
to explain:</p></div>
<div class="ulist"><ul><li><p>your usage of the toolkit</p><div class="ulist"><ul><li><p>generation of measurement result reports</p></li></ul></div></li><li><p>the missing feature</p><div class="ulist"><ul><li><p>Nesting tables to combine images with measurement data tables</p></li></ul></div></li></ul></div></aside></div></section><section id="_how_to_make_the_contribution"><h2>How to make the contribution</h2><div class="slide-content"><table class="tableblock frame-all grid-all" style="width:98%"><colgroup><col style="width:26%"><col style="width:26%"><col style="width:48%"></colgroup><tbody><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>Create issue</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="imageblock"><img src="images/Open%20issue.png" alt="Open issue"></div></div></td><td class="tableblock halign-left valign-top" rowspan="4"><div><div class="paragraph"><p>Communicate
<span class="image"><img src="images/Communicate.png" alt="Communicate"></span></p></div></div></td></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>Fork repository</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="imageblock"><img src="images/Fork%20repo.png" alt="Fork repo"></div></div></td></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>Do the work</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="imageblock"><img src="images/Do%20the%20work.png" alt="Do the work"></div></div></td></tr><tr><td class="tableblock halign-left valign-top"><div><div class="paragraph"><p>Request to merge</p></div></div></td><td class="tableblock halign-left valign-top"><div><div class="imageblock"><img src="images/merge%20request.png" alt="merge request"></div></div></td></tr></table>
<aside class="notes"><div class="paragraph"><p>Paul</p></div>
<div class="ulist"><ul><li><p>Importance of communication throughout - Use the "issues" tracker in (e.g.) gitlab to record comms about proposal, talk about why/what/how to implement.</p></li><li><p>Fork repo to get own independent version of the repo in own namespace</p></li><li><p>Keep talking</p></li><li><p>Make the change, test the change, discuss the change, meet and demo the change</p></li><li><p>Create a merge request (pull request) to allow project owner to merge changes back into the master repo.</p></li></ul></div></aside></div></section><section id="_how_to_merge"><h2>How to merge</h2><div class="slide-content"><div class="olist arabic"><ol class="arabic"><li><p>Check out the contributor&#8217;s branch in the project repository</p></li><li><p>Check the modifications</p></li><li><p>Merge into the official project</p></li></ol></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section><section id="_what_was_the_contribution_result"><h2>What was the contribution result</h2><div class="slide-content"><div class="ulist"><ul><li><p>The contribution ended up with a new release of the toolkit</p></li><li><p>The feature added enables an advanced way to create tables in an AsciiDoc file</p></li></ul></div>
<div class="imageblock"><img src="images/asciidoc-table-palette.png" alt="asciidoc table palette"></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div></aside></div></section></section>
<section><section id="_conclusion" class="lightbg" data-background-image="images/section-background.png" data-background-opacity="1"><h2>Conclusion</h2><div class="slide-content"><div class="ulist"><ul><li><p>What we learn during this collaboration</p></li></ul></div><aside class="notes"></aside></div></section><section id="_the_contributor"><h2>The contributor</h2><div class="slide-content"><div class="paragraph"><p>It&#8217;s a win-win!</p></div>
<div class="ulist"><ul><li><p>Get added functionality to a toolkit you didn&#8217;t have to write all of</p></li><li><p>Get a deeper understanding of a toolkit you might otherwise <em>only</em> use</p></li><li><p>Validation! - you have to share your code with another experienced developer</p></li><li><p>Get to meet and work with someone new</p></li><li><p>Get to contribute to something bigger</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>I got a lot out of contributing to the project beyond just the tool I wanted/needed.
You have to become a team with the project owner, you have to align your idea to their vision.
Communication is key. Olivier helped to guide on where to stop with the mods and what he didn&#8217;t want etc.</p></div></aside></div></section><section id="_the_maintainer"><h2>The maintainer</h2><div class="slide-content"><div class="paragraph"><p>It&#8217;s a win-win!</p></div>
<div class="ulist"><ul><li><p>Get added functionality to your toolkit without having to write it</p></li><li><p>Get more users of the toolkit due to a wider feature base</p></li><li><p>Chance to have another pair of eyes looking at how the toolkit works</p></li><li><p>Get to meet and work with someone new</p></li></ul></div>
<aside class="notes"><div class="paragraph"><p>Olivier</p></div>
<div class="ulist"><ul><li><p>It was the first contribution that worked the way I ever dreamed of</p></li><li><p>I&#8217;d probably never added Paul&#8217;s feature</p></li><li><p>I&#8217;m always grateful for every code review because someone helps me get better</p></li><li><p>As you said, Paul, it was the opportunity to meet someone new. One year ago we didn&#8217;t know each other and now we are presenting this talk together</p></li></ul></div></aside></div></section><section id="_advice_for_a_successful_contribution"><h2>Advice for a successful contribution</h2><div class="slide-content"><table class="tableblock frame-all grid-all" style="width:100%"><colgroup><col style="width:50%"><col style="width:50%"></colgroup><thead><tr><th class="tableblock halign-left valign-top">The maintainer</th><th class="tableblock halign-left valign-top">The Contributor</th></tr><tbody><tr><td class="tableblock halign-left valign-top"><div><div class="ulist"><ul><li><p>Set contribution guidelines (include the git workflow)</p></li><li><p>Encourage discussion of ideas prior to start</p></li><li><p>Guide to keeping changes to a small area of code</p></li></ul></div></div></td><td class="tableblock halign-left valign-top"><div><div class="ulist"><ul><li><p>Read and understand the guidelines</p></li><li><p>Communicate with the maintainer</p></li><li><p>Be humble - your idea might not fit</p></li><li><p>Listen - be guided by the maintainer</p></li></ul></div></div></td></tr><tr><td class="tableblock halign-left valign-top" colspan="2"><div><div class="admonitionblock caution"><table><tr><td class="icon"><i class="fa fa-fire" title="Caution"></i></td><td class="content"><div class="paragraph"><p>The maintainer has the right to decline:</p></div>
<div class="ulist"><ul><li><p>The contribution idea, if it doesn&#8217;t fit the goal of the project</p></li><li><p>The merge request, if the code doesn&#8217;t fit the contribution guidelines</p></li></ul></div></td></tr></table></div></div></td></tr></table>
<aside class="notes"><div class="paragraph"><p>Oliver and Paul</p></div></aside></div></section></section>
<section id="_questions"><h2>Questions ?</h2><div class="slide-content"><aside class="notes"></aside></div></section></div></div><script src="reveal.js/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'edges',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: 'c/t',
  // Control which views the slide number displays on
  showSlideNumber: 'speaker',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: true,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Disables the default reveal.js slide layout so that you can use custom CSS layout
  disableLayout: false,
  // Vertical centering of slides
  center: true,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: true,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: true,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 2400,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 5,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1500,
  height: 1000,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
      { src: 'reveal.js/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1500, 1000)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1500, 1000)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1500, 1000)
});</script></body></html>